/**
* ...
* @author nicoptere
* @version 0.1
*/

package  net.nicoptere.v3d
{
	import net.nicoptere.v3d.*;

	import flash.display.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.filters.*;
	

	public class Scene3D extends MovieClip
	{
		
		static public var focalLength:Number;
		
		static public var origin:Vertex;
		
		static public var camera:Camera3D;
		
		static public var canvas:Shape;
		static public var bd:BitmapData;
		static public var bmp:Bitmap;
		
		public var bitmaps:Array;
		public var pattern:BitmapData;
		static public var RADIUS:int = 120;
		
		public var vertices:Array;
		
		public var W:Number;
		public var H:Number;
		public var D:Number;
		
		public var obj:Object3D;
		
		public function Scene3D( stage:Stage, FL:Number = 5000 ) 
		{
			
			origin = new Vertex( 0,0,0, 0xFFFF0000 );
			focalLength = FL;
			
			canvas = new Shape();
			addChild( canvas );
			
			bd = new BitmapData( 500, 500, true, 0x00000000 );
			bmp = new Bitmap( bd );
			addChild( bmp );
			
			camera = new Camera3D( 0, 0, 0 );
			camera.viewport = new Rectangle( 0,0, stage.stageWidth,stage.stageHeight);
			
			//pour faire calculer les points
			obj = new Object3D();
			
			
			//bitmaps to render
			bitmaps = [];
			var img:Class = getDefinitionByName( 'image' ) as Class;
			var src:BitmapData = new img(0,0);
			for( var i:int = 0; i < 20; i++ )
			{
				pattern = new BitmapData( src.width + 10, src.height + 10 , true, 0x00000000 );
				pattern.fillRect(pattern.rect, 0 );
				var w:Number = (i / 20 ) * 5;
				pattern.applyFilter(src, src.rect, new Point( 5, 5), new BlurFilter( w, w, 3));
				bitmaps.push( pattern );
			}
			
			reset();
			
		}
		
		
		public function reset():void
		{
			for each ( var v:Vertex in vertices )v = null;
			vertices = [];
			init( 1 );
		}
		
		public function init( max:int ):void
		{
			var i:int = 0;
			var v:Vertex;
			for( i =0; i < max; i++ )
			{
				v = new Vertex( ( Math.random()-.5 ) * 200 ,( Math.random()-.5 ) * 200,( Math.random()-.5 ) * 200 ); 
				vertices.push( v );
			}
		}
		
		public function addVertice():void
		{
			
			vertices.push( new Vertex( Math.random()-.5, Math.random()-.5,Math.random()-.5 ) );
			
			vertices = Distribute.distribute( vertices, 40 );
			rescale( RADIUS );
			
		}
		
		public function rescale( size:Number = 100 ):void
		{
			var i:int = 0;
			var v:Vertex;
			for( i =0; i < vertices.length; i++ )
			{
				v = vertices[ i ];
				v.x *= size;
				v.y *= size;
				v.z *= size;
			}
		}
		
		public function render():void
		{
			
				
			var VL:int = vertices.length;
			var v:Vertex;
			var ox:Number = bd.width/2;
			var oy:Number = bd.height/2;
			
			//canvas.graphics.clear();
			bd.fillRect( bd.rect, 0 );
			obj.update( vertices );
			
			var ry:Number = ( stage.mouseX/stage.stageWidth ) * Math.PI*2 ; 
			obj.rotationY += ( ry - obj.rotationY ) *.05; 
			var rx:Number =  ( stage.mouseY/stage.stageWidth ) * Math.PI*2;
			obj.rotationX += ( rx - obj.rotationX ) *.05;   
			
			var zmin:Number = 0;
			var zmax:Number = 0;
			var zindex:Number = 0;
			
			vertices.sortOn( 'depth', Array.DESCENDING|Array.NUMERIC );
			zmax = vertices[ vertices.length - 1 ].depth; 
			zmin = vertices[ 0 ].depth;
			
			var mapIndex:int;
			
			
			var i:int;
			for( i = 0; i < VL; i++ )
			{
				
				v = vertices[ i ];
				
				zindex = 1 - map( v.depth, zmin, zmax, 0, 1 );
				
				
				//bd.setPixel32( ox + v.screenX , oy + v.screenY, 0xFFFFFFFF );
				
				mapIndex = ( zindex * bitmaps.length-1 );
				
				mapIndex = ( mapIndex < 0 )? 0:mapIndex;
				
				pattern = bitmaps[ mapIndex ];
				
				bd.copyPixels(pattern, pattern.rect, new Point(ox+v.screenX - pattern.width/2, oy+v.screenY - pattern.height/2),null, null, true );
				
				
			}
			
			
		}
		
		public function mapBack( val:Number, min:Number, max:Number ):Number
		{
			return max - ( ( val % ( max - min ) ) * ( val / val ) );
		}
		
		public static function normalize(value:Number, minimum:Number, maximum:Number):Number 
		{
			return (value - minimum) / (maximum - minimum);
		}
		
		public static function interpolate(normValue:Number, minimum:Number, maximum:Number):Number 
		{
			return minimum + (maximum - minimum) * normValue;
		}
		
		public static function map(value:Number, min1:Number, max1:Number, min2:Number, max2:Number):Number 
		{
			return interpolate( normalize(value, min1, max1), min2, max2);
		}
		
	}
	
}
